game = {}

--DEBUG SHIT
block_data = {
		{v = 0, n = "black: "},
		{v = 0, n = "score: "},
		{v = 0, n = "inv: "},
		{v = 0, n = "green: "}
	}
	
	checkrad = 50

local t = 0

--Game Variables
game_score = 0
game_time = 0

game_pause = false
game_over = false
pause_bg = love.graphics.newScreenshot()

game_tick = 0

--Game Images
fade = love.graphics.newImage("img/game/fade.png")

--BLOCKS

minDamage = 5
maxDamage = 10

block_tick = 0
block_int = 0.1

block_size = 16
block_scale = 0.5

block_fallSpeed = 300
block_fs = 1000

blocks = {}

--COLORS
color_bg = {a = {0, 100, 150}, d = {0, 100, 150}}
color_dblock = {0, 0, 0, 255} -- damage block
color_sblock = {30, 200, 0, 255} --Score block
color_iblock = {0, 255, 255, 255} --invisibility block
color_gblock = {200, 200, 0, 255} --green powerup block

--bg
bg_fs = 100

--Level stuff

level_int = 100
level_allscore = 0
level_current = 1


--PAUSE MENU
	local pause_button = {
			{i = "resume", img = love.graphics.newImage("img/menu/resume.png"), x = 0, y = 0, m = false, a = 80, da = 80},
			{i = "menu", img = love.graphics.newImage("img/menu/menu.png"), x = 0, y = 0, m = false, a = 80, da = 80},
			{i = "exit", img = love.graphics.newImage("img/menu/exit.png"), x = 0, y = 0, m = false, a = 80, da = 80}
		}
		
--GAME OVER SCREEN
	local over_button = {
			{i = "restart", img = love.graphics.newImage("img/menu/restart.png"), x = 0, y = 0, m = false, a = 80, da = 80},
			{i = "menu", img = love.graphics.newImage("img/menu/menu.png"), x = 0, y = 0, m = false, a = 80, da = 80},
			{i = "exit", img = love.graphics.newImage("img/menu/exit.png"), x = 0, y = 0, m = false, a = 80, da = 80}
		}

color_movebar = {c = {255, 255, 255, 255}, d = {255, 255, 255, 255}} 


block_type = {
		{score = 0, damage = 50, pow = "none", pval = 0}, --basic
		{score = 10, damage = 0, pow = "none", pval = 0}, --score
		{score = 5, damage = 0, pow = "inv", pval = 8}, --inv Powerup
		{score = 5, damage = 0, pow = "green", pval = 8} --score powerup
	}

function addBlock(x, y, t)
	local sr = math.random(-20, 20)
	blocks[#blocks + 1] = {
			x = x,
			y = y,
			t = t,
			s = 100 + sr,
			rem = false,
			fade = 255,
			
			damage = math.random(0, block_type[t].damage),
			score = math.random(0, block_type[t].score),
			pval =  math.random(0, block_type[t].pval),
			pow = block_type[t].pow,
			
			scale = block_scale,
			o = block_scale
		}
end

function clearBlocks()
	for i=#blocks, 1, -1 do
		table.remove(blocks, i)
	end
end

function game.reset()
	clearBlocks()
	msg.clear()
	player.reset()
	game_pause = false
	game_over = false
	
	player.green = false
	player.inv = false
	
	color_bg.d = {0, 100, 150}
	game_score = 0
	game_time = 0
	game_tick = 0
	level_current = 1
	level_allscore = 0
	love.timer.step()
end

function game.update(dt)
	local mx, my = love.mouse.getPosition()
	if game_pause then
		for i,v in ipairs(pause_button) do
			local w = v.img:getWidth()
			local h = v.img:getHeight()
			local m = false
			
			if mx > v.x and mx < v.x + w and my > v.y and my < v.y + h then
				m = true
			end
			
			v.m = m
			
			if v.m then
				v.da = a.maxi
			else
				v.da = a.mini
			end
			
			--BUTTON ALPHA
			if v.a < v.da then
				if v.a < a.maxi then
					v.a = v.a + a.fs * dt
				else
					v.a = a.maxi
				end
			elseif v.a > v.da then
				if v.a > a.mini then
					v.a = v.a - a.fs * dt
				else
					v.a = a.mini
				end
			end
		end
	elseif game_over then
		--GAME OVER SCREEN UPDATE
		for i,v in ipairs(over_button) do
			local w = v.img:getWidth()
			local h = v.img:getHeight()
			local m = false
			
			if mx > v.x and mx < v.x + w and my > v.y and my < v.y + h then
				m = true
			end
			
			v.m = m
			
			if v.m then
				v.da = a.maxi
			else
				v.da = a.mini
			end
			
			--BUTTON ALPHA
			if v.a < v.da then
				if v.a < a.maxi then
					v.a = v.a + a.fs * dt
				else
					v.a = a.maxi
				end
			elseif v.a > v.da then
				if v.a > a.mini then
					v.a = v.a - a.fs * dt
				else
					v.a = a.mini
				end
			end
		end
	else
	
		--GAME TICK LOOP
		game_tick = game_tick + dt
		if game_tick > 1 then
			game_time = game_time + 1
			game_tick = 0
		end
		
		--BLOCK TICK LOOP
		block_tick = block_tick + dt
		if block_tick > block_int - (0.01 * level_current) then
			local r = math.random(0, 1000)
			local b = 0
			
			if not player.inv and not player.green then --NORMAL
				if r > 200 + (2 * level_current) then
					b = 1
				elseif r > 50 and r < 200 - (2 * level_current) then
					b = 2
				else
					b = math.random(3, 4)
				end
			elseif player.inv then -- INVISIBLE
				if r > 350 then
					b = 1
				elseif r > 2 and r < 350 then
					b = 2
				else
					b = 3
				end
			elseif player.green then --GREEN
				b = 2
			end
			
			addBlock(math.random(0, screen.w - block_size), -block_size, b)
			
			--block_data[b].v = block_data[b].v + 1
			
			block_tick = 0
		end

		--block update
		--LOOP
		for i,v in ipairs(blocks) do
			--Position update
			v.y = v.y + v.s * dt
			
			--Collision
			
			if checkCollision(player.x, player.y, player.w, player.h, v.x, v.y, block_size, block_size) and not v.rem and getDistance(v.x, v.y, player.x, player.y) < checkrad then
				if v.t == 1 then
					if not player.inv then
						if player.move_time > 0 then
							player.move_time = player.move_time - v.damage
						else
							game.reset()
						end
						msg.print("-"..v.damage, player.x, player.y, 0.5, 12, col.black)
						v.rem = true
					end
				elseif v.t == 2 then --SCORE
					game_score = game_score + v.score
					level_allscore = level_allscore + v.score
					msg.print("+"..v.score, player.x, player.y, 0.5, 12, col.green)
					v.rem = true
					
					--Level updates
					if game_score > level_int * level_current then
						level_current = level_current + 1
						msg.print("Level "..level_current, screen.c, 300, 1, 24, col.white) 
					end
				elseif v.t == 3 or v.t == 4 then
					if v.pow == "inv" then
						if player.inv then
							msg.print("invisibility +"..v.pval, player.x, player.y, 0.5, 12, col.white)
						else
							msg.print("invisibility", player.x, player.y, 0.5, 12, col.white)
						end
						player.inv = true
						player.inv_time = player.inv_time + v.pval
						v.rem = true
					elseif v.pow == "green" then
						if player.green then
							msg.print("green +"..v.pval, player.x, player.y, 0.5, 12, col.white)
						else
							msg.print("green", player.x, player.y, 0.5, 12, col.white)
						end
						player.green = true
						player.green_time = player.green_time + v.pval
						v.rem = true
					end
				end
			end
			
			--remove
				if v.rem then
					v.fade = v.fade - block_fs * dt
					v.s = v.s - 200 * dt
					v.scale = v.scale + 5 * dt
					v.o = block_scale
					if v.fade < 0 + (v.s / 2) then
						table.remove(blocks, i)
					end
				end
			
		---Off screen remove
			if v.y > screen.h then
				table.remove(blocks, i)
			end
			
		if player.inv and v.t == 1 then
			if v.fade > 130 then
				v.fade = v.fade - player.inv_fade * dt
			else
				player.col[4] = 130
			end
		else
			if v.fade <= 210 then
				v.fade = v.fade + player.inv_fade * dt
			else
				v.fade = 210
			end
		end
		
		end
		
		
		
		--Power Update
		if player.inv then
			if player.inv_time >= 1 then
				player.inv_time = player.inv_time - dt
			else
				player.inv = false
				player.inv_time = 0
			end
		end
		
		if player.green then
			color_bg.d = {0, 150, 0}
			--player.col.d = {0, 255, 0, 255}
			if player.green_time >= 1 then
				player.green_time = player.green_time - dt
			else
				color_bg.d = {0, 100, 150}
				--player.col.d = {255, 255, 255, 80}
				player.green = false
				player.green_time = 0
			end
		end
		
		--BG color
		
		
		for i=1, 3 do
			if color_bg.a[i] < color_bg.d[i] - 1 then
				color_bg.a[i] = color_bg.a[i] + bg_fs * dt
			elseif color_bg.a[i] > color_bg.d[i] + 1 then
				color_bg.a[i] = color_bg.a[i] - bg_fs * dt
			else
				color_bg.a[i] = color_bg.d[i]
			end
		end
		
		
		love.graphics.setBackgroundColor(color_bg.a[1], color_bg.a[2], color_bg.a[3])
		
		
		
		player.update(dt)
		msg.update(dt)
	end
end

local winfont = love.graphics.newFont(24)

function game.draw()
	if game_pause then
		--background
		if love.graphics.isSupported("pixeleffect") then
			love.graphics.setPixelEffect(bw)
		end
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(pause_bg)
		if love.graphics.isSupported("pixeleffect") then
			love.graphics.setPixelEffect()
		end
		love.graphics.setColor(0, 0, 0, 50)
		love.graphics.rectangle("fill", 0, 0, screen.w, screen.h)
		
		--foreground
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(logo, screen.c - (logo:getWidth() / 2), 100)
		
		local sx = 275
		local offset = 69
		
		for i,v in ipairs(pause_button) do
			v.x = screen.c - (v.img:getWidth() / 2)
			v.y = sx + offset * i
		if v.m then 
			love.graphics.setColor(255, 255, 255, v.a)
		else
			love.graphics.setColor(255, 255, 255, v.a)
		end
			love.graphics.draw(v.img, v.x, v.y)
		end
	elseif game_over then
		--GAME OVER SCREEN UPDATE
		love.graphics.setPixelEffect(bw)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(pause_bg)
		love.graphics.setPixelEffect()
		love.graphics.setColor(0, 0, 0, 50)
		love.graphics.rectangle("fill", 0, 0, screen.w, screen.h)
		
		--foreground
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(logo, screen.c - (logo:getWidth() / 2), 100)
		
		--WIN INFO
		love.graphics.setFont(winfont)
		local winstring = "Score: "..game_score.." - Time: "..game_time.." - Level: "..level_current
		love.graphics.print(winstring, screen.c - (winfont:getWidth(winstring) / 2), 300)
		
		local sx = 275
		local offset = 69
		
		for i,v in ipairs(over_button) do
			v.x = screen.c - (v.img:getWidth() / 2)
			v.y = sx + offset * i
		if v.m then 
			love.graphics.setColor(255, 255, 255, v.a)
		else
			love.graphics.setColor(255, 255, 255, v.a)
		end
			love.graphics.draw(v.img, v.x, v.y)
		end
	else
		--BG
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(fade)

		
		
		love.graphics.setColor(color_movebar.c[1], color_movebar.c[2], color_movebar.c[3], color_movebar.c[4])
		love.graphics.rectangle("fill", 12, screen.h - 24, player.move_time, 12)
		love.graphics.setColor(0, 0, 0)
		love.graphics.rectangle("line", 12, screen.h - 24, player.move_maxTime, 12)

		
		--Blocks
		for i,v in ipairs(blocks) do
			if v.t == 1 then
				love.graphics.setColor(color_dblock[1], color_dblock[2], color_dblock[3], v.fade - (v.s / 1.5))
			elseif v.t == 2 then
				love.graphics.setColor(color_sblock[1], color_sblock[2], color_sblock[3], v.fade - (v.s / 1.5))
			elseif v.t == 3 then
				love.graphics.setColor(color_iblock[1], color_iblock[2], color_iblock[3], v.fade - (v.s  / 1.5))
			elseif v.t == 4 then
				love.graphics.setColor(color_gblock[1], color_gblock[2], color_gblock[3], v.fade - (v.s / 1.5))
			end
			--love.graphics.rectangle("fill", v.x, v.y, block_size, block_size)
			love.graphics.draw(player.img, v.x, v.y, 0, v.scale, v.scale, v.o, v.o)
		end
		
		player.draw()
		
		--love.graphics.setColor(0, 0, 0, 25)
		--love.graphics.circle("fill", player.x, player.y, checkrad)
		
		--HUD
		love.graphics.setFont(f)
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("Score: "..game_score.."\nTime: "..game_time.."\nLevel: "..level_current, 12, 12)
	
		
		--for o,b in ipairs(block_data) do
		--	love.graphics.print(b.n..b.v, 12, 200 + 24 * o) 
		--end
		
		msg.draw()
	end
end

function game.keypressed(key)
	if key == "escape" then
		if game_pause then
			game_pause = false
		elseif not game_pause and not game_over then
			local s = love.graphics.newScreenshot()
			pause_bg = love.graphics.newImage(s)
			game_pause = true
		end
	end
end

function game.mousepressed(x, y, k)
	if k == "l" then
		if game_pause then
			for i,v in ipairs(pause_button) do
				if v.m then
					if v.i == "resume" then
						game_pause = false
					elseif v.i == "menu" then
						gamestate = state.menu
						game.reset()
					elseif v.i == "exit" then
						love.event.push("quit")
					end
				end
			end
		elseif game_over then
			--GAME OVER MOUSE
			for i,v in ipairs(over_button) do
				if v.m then
					if v.i == "restart" then
						game.reset()
					elseif v.i == "menu" then
						gamestate = state.menu
						game.reset()
					elseif v.i == "exit" then
						love.event.push("quit")
					end
				end
			end
		end
	end
end











