menu = {}

a = {
		mini = 80,
		maxi = 240,
		fs = 600
	}

button = {
		{i = "start", img = love.graphics.newImage("img/menu/start.png"), x = 0, y = 0, m = false, a = a.mini, da = a.mini},
		--{i = "options", img = love.graphics.newImage("img/menu/options.png"), x = 0, y = 0, m = false, a = 255, da = 255},
		{i = "exit", img = love.graphics.newImage("img/menu/exit.png"), x = 0, y = 0, m = false, a = a.mini, da = a.mini}
	}
logo = love.graphics.newImage("img/menu/logo.png")

local block_mInt = 0.4
local block_mSpeed = 60

function menu.update(dt)
	block_tick = block_tick + dt
		if block_tick > block_mInt then
			local r = math.random(0, 1000)
			local b = 0
			
			if r > 100 then
				b = 1
			elseif r > 10 and r < 100 then
				b = 2
			else
				b = 3
			end
			addBlock(math.random(0, screen.w - block_size), -block_size, b)
			block_tick = 0
		end

	for i,v in ipairs(blocks) do
		v.y = v.y + block_mSpeed * dt
		
		if v.y > screen.h then
			table.remove(blocks, i)
		end
	end
	
	--mouse stuffs
	local mx, my = love.mouse.getPosition()
	for i,v in ipairs(button) do
		local w = v.img:getWidth()
		local h = v.img:getHeight()
		local m = false
		
		if mx > v.x and mx < v.x + w and my > v.y and my < v.y + h then
			m = true
		end
		
		v.m = m
		
		if v.m then
			v.da = a.maxi
		else
			v.da = a.mini
		end
		
		--BUTTON ALPHA
		if v.a < v.da then
			if v.a < a.maxi then
				v.a = v.a + a.fs * dt
			else
				v.a = a.maxi
			end
		elseif v.a > v.da then
			if v.a > a.mini then
				v.a = v.a - a.fs * dt
			else
				v.a = a.mini
			end
		end
	end

	--bg color
	for i=1, 3 do
		if color_bg.a[i] < color_bg.d[i] - 1 then
			color_bg.a[i] = color_bg.a[i] + bg_fs * dt
		elseif color_bg.a[i] > color_bg.d[i] + 1 then
			color_bg.a[i] = color_bg.a[i] - bg_fs * dt
		else
			color_bg.a[i] = color_bg.d[i]
		end
	end
		love.graphics.setBackgroundColor(color_bg.a[1], color_bg.a[2], color_bg.a[3])
end

function menu.draw()
	--love.graphics.setColor(255, 255, 255, 100)
	--love.graphics.draw(design)
	
	--BG BLOCKS
	for i,v in ipairs(blocks) do
			if v.t == 1 then
				love.graphics.setColor(color_dblock[1], color_dblock[2], color_dblock[3], 80)
			elseif v.t == 2 then
				love.graphics.setColor(color_sblock[1], color_sblock[2], color_sblock[3], 80)
			elseif v.t == 3 then
				love.graphics.setColor(color_iblock[1], color_iblock[2], color_iblock[3], 80)
			end
			love.graphics.draw(player.img, v.x, v.y, 0, 0.5, 0.5)
		end
	
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(fade)
	
	love.graphics.draw(logo, screen.c - (logo:getWidth() / 2), 100)
	
	local sx = 275
	local offset = 69
	
	--BUTTONS
	for i,v in ipairs(button) do
		v.x = screen.c - (v.img:getWidth() / 2)
		v.y = sx + offset * i
		if v.m then 
			love.graphics.setColor(255, 255, 255, v.a)
		else
			love.graphics.setColor(255, 255, 255, v.a)
		end
		love.graphics.draw(v.img, v.x, v.y)
	end
end

function menu.keypressed(key)
	if key == "escape" then
		love.event.push("quit")
	end
end

function menu.mousepressed(x, y, k)
	if k == "l" then
		for i,v in ipairs(button) do
			if v.m then
				if v.i == "start" then
					game.reset()
					gamestate = state.game
				elseif v.i == "options" then
					
				elseif v.i == "exit" then
					love.event.push("quit")
				end
			end
		end
	end
end

















